'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by matan on 1/5/16.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HandlerResponse = function () {
  /**
   * Creates an objects that bundles an extended response that a handlers can return.
   * This allows the handler to control the returned message properties & headers instead of them
   * being automatically generated by the sender based on the original message.
   * The message must obey rabbitMQ headers, properties & payload rules.
   * @param {string|number|[string]|[number]} body - The message main payload
   * @param {object=} [originalMessage] - If passed take default properties, headers & reply queue
   * @param {object} headers - An object containing free headers to send.
   * @param {object} properties - An object containing rabbitMQ headers the handler wishes to send.
   * from it. In case of an overlap with properties/headers this parameters is WEAKER.
   * @constructor
   */
  function HandlerResponse(body, originalMessage) {
    var headers = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var properties = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    _classCallCheck(this, HandlerResponse);

    // Initializes response data members
    this.body = body;
    this.properties = {};
    this.headers = {};
    this.msg = originalMessage;

    // Extract properties from the original messager
    if (originalMessage) {
      this.properties.correlationId = originalMessage.properties.messageId;
      this.headers.topic = originalMessage.headers.topic;
      this.meta = originalMessage.headers.meta;
      this.replyTo = originalMessage.properties.replyTo;
    }

    // In case of overlapping fields lodash extend gives priority to values from the right
    // side parameter
    _lodash2.default.extend(this.headers, headers);

    var replyTo = properties.replyTo,
        otherProperties = _objectWithoutProperties(properties, ['replyTo']);

    _lodash2.default.extend(this.properties, otherProperties);
    if (replyTo) {
      this.replyTo = replyTo;
    }
  }

  /**
   * Format handler's response as rabbit's options
   * @returns {Object|void|*}
   */


  _createClass(HandlerResponse, [{
    key: 'toRabbitOptions',
    value: function toRabbitOptions() {
      var options = _lodash2.default.extend({}, this.properties);
      options.headers = _lodash2.default.extend({}, this.headers);
      return options;
    }
  }]);

  return HandlerResponse;
}();

exports.default = HandlerResponse;