'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by asafdavid on 10/12/2015.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _md = require('md5');

var _md2 = _interopRequireDefault(_md);

var _listener = require('./listener');

var _listener2 = _interopRequireDefault(_listener);

var _sender = require('./sender');

var _sender2 = _interopRequireDefault(_sender);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Worker = function () {
  function Worker(_ref) {
    var name = _ref.name,
        conn = _ref.conn,
        domain = _ref.domain,
        queue = _ref.queue,
        router = _ref.router,
        config = _ref.config,
        options = _ref.options;

    _classCallCheck(this, Worker);

    this.name = name;
    this.conn = conn;
    this.domain = domain;
    this.queue = queue;
    this.router = router;
    this.config = config || _bluebird2.default.resolve();
    this.options = options || {};

    if (this.options.logger) {
      _logger2.default.setLogger(this.options.logger);
    }

    // Saves the requests promises this worker handles
    this.routePromise = {};
  }

  _createClass(Worker, [{
    key: 'start',
    value: function start() {
      var _this = this;

      var consumerTag = this.options.consumerTag ? this.options.consumerTag + '-worker' : undefined;
      this.conn.connect();
      this.conn.on('open', function () {
        _logger2.default.instance.info('[AMQP] channel is open');
        _this.config().then(function () {
          _this.listener = new _listener2.default(_this.conn.channel, _this.domain + '.' + _this.queue, consumerTag, _this.options.qosLimit, _this.options.pull);

          _this.sender = new _sender2.default(_this.conn.channel, _this.options.errExchange, _this.options.nackExchange, _this.options.timeoutExchange, _this.options.timeoutQueueName, _this.options.queueExpiration);
        }).then(function () {
          _this.listener.start();
          _this.listener.on('msg', function (msg) {
            // Creating unique entry to wait for promise when stopping
            var entry = (0, _md2.default)(msg) + ':' + Date.now();
            _this.routePromise[entry] = _this.router.route(_this.sender, msg).then(function () {
              delete _this.routePromise[entry];
            });
          });
        });
      });
    }
  }, {
    key: 'stop',
    value: function stop() {
      var _this2 = this;

      _logger2.default.instance.info('[AMQP] Stopping worker...');
      return _bluebird2.default.resolve().then(function () {
        return _this2.listener.stop();
      }).then(function () {
        return _bluebird2.default.props(_this2.routePromise);
      }).finally(function () {
        return _this2.conn.close();
      });
    }
  }]);

  return Worker;
}();

exports.default = Worker;